# Find the native XercesC includes and library
#
# This module defines
#  XercesC_INCLUDE_DIR, where to find xercesc headers
#  XercesC_LIBRARY, where to find the xercesc library.
#  XercesC_FOUND, If false, do not try to use XercesC.

FIND_PATH(XercesC_INCLUDE_DIR xercesc)

FIND_LIBRARY(XercesC_LIBRARY xerces-c) 

IF (XercesC_INCLUDE_DIR AND XercesC_LIBRARY)
    SET(XercesC_FOUND TRUE)
ELSE(XercesC_INCLUDE_DIR AND XercesC_LIBRARY)
    SET(XercesC_FOUND FALSE)
ENDIF (XercesC_INCLUDE_DIR AND XercesC_LIBRARY)

IF (XercesC_FOUND)
   IF (NOT XercesC_FIND_QUIETLY)
      MESSAGE(STATUS "Found xerces-c: ${XercesC_LIBRARY}")
   ENDIF (NOT XercesC_FIND_QUIETLY)
ELSE (XercesC_FOUND)
   IF (XercesC_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find xerces-c")
   ENDIF (XercesC_FIND_REQUIRED)
ENDIF (XercesC_FOUND)
