/*
 * This software is Copyright (C) 2006-2009
 * Fachhochschule Hannover (University of Applied Sciences and Arts)
 * Use is subject to license conditions.
 *
 * The main licensing options available are:
 *
 * Open Source Licensing. This is the appropriate option if you want to
 * share the source code of your application with everyone you
 * distribute it to, and you also want to give them the right to share
 * who uses it. If you wish to use TNC@FHH under Open Source Licensing,
 * you must contribute all your source code to the open source
 * community in accordance with the GPL Version 2 when your application
 * is distributed. See http://www.gnu.org/copyleft/gpl.html
 *
 * Commercial Licensing. This is the appropriate option if you are
 * creating proprietary applications and you are not prepared to
 * distribute and share the source code of your application.
 * Contact trust@f4-i.fh-hannover.de for details.
 * 
 * http://trust.inform.fh-hannover.de/
 */
#ifndef TNCS_TNCCTNCSMESSAGEXML_H_
#define TNCS_TNCCTNCSMESSAGEXML_H_

#include "TNCCTNCSMessage.h"

#include <xercesc/dom/DOM.hpp>

namespace tncfhh {

namespace iel {

namespace tnc1 {

/**
 * TODO_Comment
 * 
 * <h3>Changelog:</h3>
 * <ul>
 *   <li>05.03.2008 - create class (mbs)</li>
 *   <li>20.07.2009 - redesign for 0.6.0 (mbs)</li>
 * </ul>
 *
 * @class TNCCTNCSMessageXML
 * @brief Represent a TNCC-TNCS-Message with XML data
 * @date 05.03.2008
 * @author Mike Steinmetz (mbs)
 */
class TNCCTNCSMessageXML : public TNCCTNCSMessage
{
public:
	
	/**
	 * TODO_Comment
	 *
	 * @param type
	 * @param xml create an deep copy from this xml document
	 */
	TNCCTNCSMessageXML(TNC_MessageType type, xercesc::DOMElement * xml);

	/**
	 * TODO_Comment
	 *
	 * @param type
	 * @param doc is released by this class
	 * @param xml this released by this class, too?
	 */
	TNCCTNCSMessageXML(TNC_MessageType type, xercesc::DOMDocument * doc, xercesc::DOMElement * xml);
	
	virtual ~TNCCTNCSMessageXML();
	virtual xercesc::DOMElement * getXML();
private:
	xercesc::DOMDocument * doc;
	xercesc::DOMElement * xml;
};

}  // namespace tnc1

}  // namespace iel

}  // namespace tncfhh

#endif /*TNCCTNCSMESSAGEXML_H_*/
